<template>
  <div class="card-template" v-on:click="navigateProductDetail(item)">
    <div class="sale-sticker" v-if="item.discount"><span>SALE</span></div>
    <div class="card mb-4 shadow-sm">
      <div class="bg-image-animate">
        <div
          class="product-img"
          alt="Card image cap"
          :style="`background-image: url('${getImageUrl()}')`"
          >
        </div>

        <div
          class="product-img"
          :style="`background-image: url('${getImageUrl(true)}')`"
          alt="Card image cap"
          >
        </div>
      </div>
      <div class="product-body" >
        <h6 class="card-text">{{item.productName}}</h6>

        <div class="d-flex cart-item-price">
          <p class="card-price" :class="{'old-price': item.discount}" v-text="getPrice(item)"></p>
          <p v-if="item.discount" class="ml-2 card-price discount-price" v-text="getPrice(item, true)"></p>
        </div>

        <div class="actions-panel d-flex align-items-center">
          <div class="btn-group">
            <button
              type="button"
              class="action-button main-button"
              v-on:click="navigateProductDetail(item)"
            >Смотреть</button>
            
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions, mapMutations } from "vuex";

import _ from "lodash";
export default {
  name: "cardTemplate",
  props: ["item"],
  components: {},
  computed: mapState(["loggedUser"]),
  methods: {
    navigateProductDetail(product) {
      this.$router.push({
        name: "productDetails",
        params: { id: product._id }
      });
    },
    getImageUrl(secondary) {
      if (secondary) return this.item.files.find(f => !f.main && !f.video).url;
      return this.item.files.find(f => f.main).url;
    },
    getPrice(product, discount) {
      if (discount) {
        let price = product.items[0].price;

        price = parseFloat(price) - (price * (product.discount / 100));
        return `${price} UAH`;
      } else {
        let price = product.items[0].price;
        return `${price} ${product.discount ? '' : 'UAH'}`;
      }
    }
  }
};
</script>
<style lang="scss">
  .card-template {
    position: relative;
    .card {
      height: 450px;
    }

    @media (max-width: 768px) {
      .card {
        height: 310px;
      }
      .card-text {
        font-size: 16px;
        margin-bottom: 3px;
        min-height: 38px;
        word-break: break-all;
      }
      .card-price {
        margin-bottom: 3px;
      }
    }
  }
  .product-body {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    padding: 10px;
    .actions-panel {
      justify-content: space-between;
    }
    @media (max-width: 768px) {
      .actions-panel {
        display: none !important;
      }
    }
    .action-button {
      width: 85px;
      font-size: 14px;
      padding: 10px 8px;
      margin-top: 0;
    }
    .card-price {
      font-size: 14px;
    }
    .fa-shopping-cart {
      color: #b19d75;
    }
  }
  .product-img {
    width: 100%;
    max-width: 330px;
    margin: 0px auto;
    height: 313px;
    background-position: center;
    background-size: contain;
    background-repeat: no-repeat;
    background-color: #ded6c1;
  }

  @media (max-width: 768px) {
    .product-img {
      width: 100%;
      height: 210px;
    }
  }

  .bg-image-animate {
      position: relative;
      min-height: 310px;
  }
  .bg-image-animate  > div{
      display: block;
      position: absolute;
      /* transitions */
      -webkit-transition: all .8s ease;
         -moz-transition: all .8s ease;
          -ms-transition: all .8s ease;
           -o-transition: all .8s ease;
              transition: all .8s ease;
      
  }

  .bg-image-animate  > div:nth-child(1){
      filter: alpha(opacity=100); 
      opacity: 1;
      z-index: 2;
  }
  .bg-image-animate  > div:nth-child(2){
      filter: alpha(opacity=0); 
      opacity: 0;
      z-index: 1;
  }
  /* hover */
  .bg-image-animate:hover > div:nth-child(1){ 
      filter: alpha(opacity=0);
      opacity: 0;
      z-index: 1;
  }
  .bg-image-animate:hover > div:nth-child(2){ 
      filter: alpha(opacity=100);
      opacity: 1;
      z-index: 2;
  }
  @media (max-width: 768px) {
    .bg-image-animate {
      height: 210px;
      min-height: auto;
    }
  }
</style>